defmodule NullaWeb.UserController do
  use NullaWeb, :controller
  alias Nulla.Users
  alias Nulla.InstanceSettings
  alias Nulla.ActivityPub

  def show(conn, %{"username" => username}) do
    accept = List.first(get_req_header(conn, "accept"))
    instance_settings = InstanceSettings.get_instance_settings!()
    domain = instance_settings.domain
    user = Users.get_user_by_username!(username)

    if accept in ["application/activity+json", "application/ld+json"] do
      conn
      |> put_resp_content_type("application/activity+json")
      |> json(ActivityPub.ap_user(domain, user))
    else
      render(conn, :show, user: user, domain: domain, layout: false)
    end
  end
end
